using UnityEngine;


[RequireComponent (typeof(AudioSource))]
public class AudioSourceGetSpectrumDataExample : MonoBehaviour
{
  AudioSource aSource;

  void Start()
  {
    aSource = GetComponent<AudioSource>();
  }

  void Update( )
  {
    float[] spectrum = new float[64];

    aSource.GetSpectrumData( spectrum, 0, FFTWindow.BlackmanHarris );

    for( int i = 1; i < spectrum.Length-1; i++ )
    {
      Debug.DrawLine( new Vector3( i - 1, spectrum[i] + 10, 0 ), new Vector3( i, spectrum[i + 1] + 10, 0 ), Color.red );
      Debug.DrawLine( new Vector3( i - 1, Mathf.Log( spectrum[i - 1] ) + 10, 2 ), new Vector3( i, Mathf.Log( spectrum[i] ) + 10, 2 ), Color.cyan );
      Debug.DrawLine( new Vector3( Mathf.Log( i - 1 ), spectrum[i - 1] - 10, 1 ), new Vector3( Mathf.Log( i ), spectrum[i] - 10, 1 ), Color.green );
      Debug.DrawLine( new Vector3( Mathf.Log( i - 1 ), Mathf.Log( spectrum[i - 1] ), 3 ), new Vector3( Mathf.Log( i ), Mathf.Log( spectrum[i] ), 3 ), Color.blue );
    }
  }
}