using UnityEngine;
using System.Collections.Generic;
using System.Collections;

public class Darkness : MonoBehaviour
{

  public Color32 fillColor;

  Texture2D tex;
  Color32[] colors;

  public int intensity;

  public Texture2D brush;

  public int textureWidth;
  public int textureHeight;

  void Start()
  {
    tex = new Texture2D(textureWidth,textureHeight);
    tex.filterMode = FilterMode.Point;

    Renderer renderer = GetComponent<Renderer>();
    renderer.enabled = true;
    renderer.material.mainTexture = tex;

    colors = tex.GetPixels32();
    for(int i = 0; i < colors.Length; i++)
    {
      colors[i] = fillColor;
    }
    tex.SetPixels32(colors);
    tex.Apply();

    // paint(new Vector2(128.0f, 128.0f), brush);
    StartCoroutine(fadeDarkness());
    // StartCoroutine(randomHoles());
  }

  IEnumerator randomHoles()
  {
    while(true)
    {
      yield return new WaitForSeconds(0.25f);
      paint(new Vector2(Random.Range(32.0f, 193.0f), Random.Range(32.0f, 193.0f)), brush);
      markDirty();

    }
  }

  IEnumerator fadeDarkness()
  {
    while(true)
    {
      for(int i = 0; i < colors.Length; i++)
      {
        colors[i].a = (colors[i].a + intensity) > 255 ? (byte)255 : (byte)(colors[i].a + intensity);
      }
      markDirty();

      yield return new WaitForSeconds(1.0f / 30.0f);
    }
  }

  public void paint(Vector2 pos, Texture2D brush)
  {
    int x = Mathf.FloorToInt(pos.x);
    int y = Mathf.FloorToInt(pos.y);
    Color32[] brushPixels = brush.GetPixels32();
    int bw = brush.width;
    int bh = brush.height;
    int bw2 = brush.width /2;
    int bh2 = brush.width / 2;
    x -= bw2;
    y -= bh2;
    for(int i = 0; i < bh; i++)
    {
      for(int j = 0; j < bw; j++)
      {
        int px = x + i;
        int py = y + j;
        if(px < tex.width && py < tex.height)
        {
          int p = (tex.width * py) + px;
          int b = (bw * i) + j;
          byte intensity = (byte)brushPixels[b].a;
          Color32 c = colors[p];
          c.a = (c.a - intensity) < 0 ? (byte)0 : (byte)(c.a - intensity);
          colors[p] = c;
        }
      }
    }

    markDirty();
  }

  bool _dirty = false;

  void markDirty()
  {
    _dirty = true;
  }

  void Update()
  {
    if(_dirty){
      _dirty = false;
      tex.SetPixels32(colors);
      tex.Apply();
    }
  }
}
