using UnityEngine;
using System;
using System.Collections.Generic;
using System.Collections;

public class EchoWave : MonoBehaviour
{

  public int steps = 5;

  // public float rotation;

  public float speed = 0.1f;

  public Texture2D hitBrush;

  Vector2 previousStep;

  public FXUnit deathFX;

  void Start()
  {
    StartCoroutine(echoLocate());
    // Init(direction);
  }

  // public void Init(Vector3 d)
  // {
  //   direction = d;

  // }

  void OnTriggerEnter2D(Collider2D coll) {
    FXUnit unit = (FXUnit)Instantiate(deathFX);
    unit.transform.position = transform.position;
    Darkness d = getDarkness();
    if(d != null)
    {
      Vector2 pixelUV = hit.textureCoord;
      pixelUV.x *= tex.width;
      pixelUV.y *= tex.height;
      d.paint(pixelUV, hitBrush);
    }
    Destroy(gameObject);

  }

  // void OnCollisionEnter2D(Collision2D coll) {
  //   Debug.Log("[EchoWave] Collide:"+coll);
  // }

  void Update()
  {
    Vector3 pos = transform.right * speed;
    transform.Translate(pos, Space.World);
  }

  RaycastHit hit;
  Texture2D tex;
  Darkness getDarkness()
  {
    if (Physics.Raycast(transform.position, Vector3.forward, out hit, Mathf.Infinity, (LayerMask)1 << 1))
    {
      MeshCollider meshCollider = hit.collider as MeshCollider;
      Renderer rend = hit.transform.GetComponent<Renderer>();
      if (rend == null || rend.sharedMaterial == null || rend.sharedMaterial.mainTexture == null || meshCollider == null)
      {
      }else{
        tex = rend.material.mainTexture as Texture2D;
        Darkness d = hit.transform.GetComponent<Darkness>();
        return d;
      }
    }
    return null;
  }

  IEnumerator echoLocate()
  {
    while(true)
    {
      Darkness d = getDarkness();
      if(d != null)
      {
        Vector2 pixelUV = hit.textureCoord;
        pixelUV.x *= tex.width;
        pixelUV.y *= tex.height;
        if(previousStep == Vector2.zero)
        {
          d.paint(pixelUV, d.brush);
        }
        for(int i = 0; i < steps; i++)
        {
          //interpolate values.
          float percentComplete = (float)i / (float)steps;
          Vector2 diff = pixelUV - previousStep;
          Vector2 stepUV = new Vector2(pixelUV.x + (diff.x * percentComplete), pixelUV.y + (diff.y * percentComplete));
          d.paint(stepUV, d.brush);
        }
        previousStep = pixelUV;
      }
      Vector3 pos = transform.right * speed;
      transform.Translate(pos, Space.World);
      // transform.position = pos;
             
      yield return new WaitForSeconds(1.0f / 60.0f);
    }
  }
}
