using UnityEngine;
using System.Collections;

[RequireComponent(typeof(AudioSource))]
public class MicrophoneInput : MonoBehaviour {
    public int duration = 1;

    string AudioInputDevice;

    public AudioSource asource;

    public int pos;
    public int asourcePos;

    void Start() {
        // Debug.Log("[MicrophoneInput] Devices;");
        foreach(string device in Microphone.devices)
        {
            // Debug.Log("[MicrophoneInput] "+device);
        }
        if(Microphone.devices.Length > 0)
        {
            AudioInputDevice = Microphone.devices[0];
            int minFreq;
            int maxFreq;
            Microphone.GetDeviceCaps(AudioInputDevice, out minFreq, out maxFreq);
            Debug.Log("[MicrophoneInput] Using:"+AudioInputDevice+ " min:"+minFreq+" max:"+maxFreq);
        }else{
            Debug.Log("[MicrophoneInput] No input devices found! :(");
        }
        asource = GetComponent<AudioSource>();
        asource.clip = Microphone.Start(AudioInputDevice, true, duration, 44100);
        asource.loop = true; // Set the AudioClip to loop
        // asource.mute = true; // Mute the sound, we don't want the player to hear it
        while (!(Microphone.GetPosition(AudioInputDevice) <= 0)){} // Wait until the recording has started
        asource.Play(); // Play the asource source!
    }

    void Update()
    {
        pos = Microphone.GetPosition(AudioInputDevice);
        asourcePos = asource.timeSamples;
    }


}