using UnityEngine;
using UnityEngine.UI;
using System;
using System.Collections.Generic;
using System.Collections;
using Pitch;

public class BellyItcher : MonoBehaviour
{
  public PitchTracker pitchTracker;
  public AudioSource aSource;
  public MicrophoneInput input;

  public float levelMax;
  float[] samples;
  int sampleNum;

  public float pitch;

  void Start()
  {
    aSource = input.asource;
    pitchTracker = new PitchTracker();
    pitchTracker.SampleRate = 44100;
    sampleNum = 44100 / 8;
    samples = new float[sampleNum * aSource.clip.channels];

  }

  void Update()
  {
    // Debug.Log("[BellyItcher] "+aSource.clip.samples);
    // float[] samples = new float[aSource.clip.samples * aSource.clip.channels];
    // float[] samples = new float[sampleNum * aSource.clip.channels];
    int pos = input.pos - sampleNum;
    if(pos < 0)
    {
      pos = sampleNum - pos;
    }
    aSource.clip.GetData(samples, pos);
    pitchTracker.ProcessBuffer(samples);
    levelMax = 0;
    for (int i = 0; i < sampleNum; i++) {
        float wavePeak = samples[i];
        if (levelMax < wavePeak) {
            levelMax = wavePeak;
        }
    }

    pitch = pitchTracker.CurrentPitchRecord.Pitch;

  }

}
