using UnityEngine;
using UnityEngine.UI;
using System;
using System.Collections.Generic;
using System.Collections;

public class Player : MonoBehaviour
{

  // The text info on-screen for the player.
  public Text playerLabel;
  // How much rest the player currently has.
  public int rest = 5;
  // How much sanity the player has left.
  public int sanity = 5;

  // The view shown when the player dies! :O
  public GameObject gameOverDead;

  // Function called by the button in the scene. Gives the player more rest!
  public void gainOneRest()
  {
    rest = rest + 1;
  }

  // Function called by the button in the scene. The player loses one sanity 
  // and if the sanity meter hits 0, he dies!
  public void loseOneSanity()
  {
    sanity = sanity - 1;
    Debug.Log("Sanity = "+ sanity);
    if(sanity == 0)
    {
      die();
    }
  }

  // When the player dies, we display the game over view by enabling the game object.
  void die()
  {
    //SetActive shows this view, which is turned off by default.
    gameOverDead.SetActive(true);
  }

  void Start()
  {
    
  }

  void Update()
  {
    // Every frame we update the information on our player text field.
    playerLabel.text = "Player Rest:"+rest+" Sanity:"+sanity;
  }
}
